Merge branch 'rs/sha1-file-close-mapped-file-on-error'
[git/git.git] / t / test-lib.sh
1 # Test framework for git. See t/README for usage.
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
17
18 # Test the binaries we have just built. The tests are kept in
19 # t/ subdirectory and are run in 'trash directory' subdirectory.
20 if test -z "$TEST_DIRECTORY"
21 then
22 # We allow tests to override this, in case they want to run tests
23 # outside of t/, e.g. for running tests on the test library
24 # itself.
25 TEST_DIRECTORY=$(pwd)
26 else
27 # ensure that TEST_DIRECTORY is an absolute path so that it
28 # is valid even if the current working directory is changed
29 TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
30 fi
31 if test -z "$TEST_OUTPUT_DIRECTORY"
32 then
33 # Similarly, override this to store the test-results subdir
34 # elsewhere
35 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
36 fi
37 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
38
39 # If we were built with ASAN, it may complain about leaks
40 # of program-lifetime variables. Disable it by default to lower
41 # the noise level. This needs to happen at the start of the script,
42 # before we even do our "did we build git yet" check (since we don't
43 # want that one to complain to stderr).
44 : ${ASAN_OPTIONS=detect_leaks=0:abort_on_error=1}
45 export ASAN_OPTIONS
46
47 # If LSAN is in effect we _do_ want leak checking, but we still
48 # want to abort so that we notice the problems.
49 : ${LSAN_OPTIONS=abort_on_error=1}
50 export LSAN_OPTIONS
51
52 if test ! -f "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
53 then
54 echo >&2 'error: GIT-BUILD-OPTIONS missing (has Git been built?).'
55 exit 1
56 fi
57 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
58 export PERL_PATH SHELL_PATH
59
60 ################################################################
61 # It appears that people try to run tests without building...
62 "${GIT_TEST_INSTALLED:-$GIT_BUILD_DIR}/git$X" >/dev/null
63 if test $? != 1
64 then
65 if test -n "$GIT_TEST_INSTALLED"
66 then
67 echo >&2 "error: there is no working Git at '$GIT_TEST_INSTALLED'"
68 else
69 echo >&2 'error: you do not seem to have built git yet.'
70 fi
71 exit 1
72 fi
73
74 # if --tee was passed, write the output not only to the terminal, but
75 # additionally to the file test-results/$BASENAME.out, too.
76 case "$GIT_TEST_TEE_STARTED, $* " in
77 done,*)
78 # do not redirect again
79 ;;
80 *' --tee '*|*' --va'*|*' -V '*|*' --verbose-log '*)
81 mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
82 BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
83
84 # Make this filename available to the sub-process in case it is using
85 # --verbose-log.
86 GIT_TEST_TEE_OUTPUT_FILE=$BASE.out
87 export GIT_TEST_TEE_OUTPUT_FILE
88
89 # Truncate before calling "tee -a" to get rid of the results
90 # from any previous runs.
91 >"$GIT_TEST_TEE_OUTPUT_FILE"
92
93 (GIT_TEST_TEE_STARTED=done ${TEST_SHELL_PATH} "$0" "$@" 2>&1;
94 echo $? >"$BASE.exit") | tee -a "$GIT_TEST_TEE_OUTPUT_FILE"
95 test "$(cat "$BASE.exit")" = 0
96 exit
97 ;;
98 esac
99
100 # For repeatability, reset the environment to known value.
101 # TERM is sanitized below, after saving color control sequences.
102 LANG=C
103 LC_ALL=C
104 PAGER=cat
105 TZ=UTC
106 export LANG LC_ALL PAGER TZ
107 EDITOR=:
108
109 # GIT_TEST_GETTEXT_POISON should not influence git commands executed
110 # during initialization of test-lib and the test repo. Back it up,
111 # unset and then restore after initialization is finished.
112 if test -n "$GIT_TEST_GETTEXT_POISON"
113 then
114 GIT_TEST_GETTEXT_POISON_ORIG=$GIT_TEST_GETTEXT_POISON
115 unset GIT_TEST_GETTEXT_POISON
116 fi
117
118 # A call to "unset" with no arguments causes at least Solaris 10
119 # /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
120 # deriving from the command substitution clustered with the other
121 # ones.
122 unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
123 my @env = keys %ENV;
124 my $ok = join("|", qw(
125 TRACE
126 DEBUG
127 TEST
128 .*_TEST
129 PROVE
130 VALGRIND
131 UNZIP
132 PERF_
133 CURL_VERBOSE
134 TRACE_CURL
135 ));
136 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
137 print join("\n", @vars);
138 ')
139 unset XDG_CACHE_HOME
140 unset XDG_CONFIG_HOME
141 unset GITPERLLIB
142 GIT_AUTHOR_EMAIL=author@example.com
143 GIT_AUTHOR_NAME='A U Thor'
144 GIT_COMMITTER_EMAIL=committer@example.com
145 GIT_COMMITTER_NAME='C O Mitter'
146 GIT_MERGE_VERBOSITY=5
147 GIT_MERGE_AUTOEDIT=no
148 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
149 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
150 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
151 export EDITOR
152
153 # Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
154 GIT_TRACE_BARE=1
155 export GIT_TRACE_BARE
156
157 check_var_migration () {
158 # the warnings and hints given from this helper depends
159 # on end-user settings, which will disrupt the self-test
160 # done on the test framework itself.
161 case "$GIT_TEST_FRAMEWORK_SELFTEST" in
162 t) return ;;
163 esac
164
165 old_name=$1 new_name=$2
166 eval "old_isset=\${${old_name}:+isset}"
167 eval "new_isset=\${${new_name}:+isset}"
168
169 case "$old_isset,$new_isset" in
170 isset,)
171 echo >&2 "warning: $old_name is now $new_name"
172 echo >&2 "hint: set $new_name too during the transition period"
173 eval "$new_name=\$$old_name"
174 ;;
175 isset,isset)
176 # do this later
177 # echo >&2 "warning: $old_name is now $new_name"
178 # echo >&2 "hint: remove $old_name"
179 ;;
180 esac
181 }
182
183 check_var_migration GIT_FSMONITOR_TEST GIT_TEST_FSMONITOR
184 check_var_migration TEST_GIT_INDEX_VERSION GIT_TEST_INDEX_VERSION
185 check_var_migration GIT_FORCE_PRELOAD_TEST GIT_TEST_PRELOAD_INDEX
186
187 # Use specific version of the index file format
188 if test -n "${GIT_TEST_INDEX_VERSION:+isset}"
189 then
190 GIT_INDEX_VERSION="$GIT_TEST_INDEX_VERSION"
191 export GIT_INDEX_VERSION
192 fi
193
194 # Add libc MALLOC and MALLOC_PERTURB test
195 # only if we are not executing the test with valgrind
196 if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
197 test -n "$TEST_NO_MALLOC_CHECK"
198 then
199 setup_malloc_check () {
200 : nothing
201 }
202 teardown_malloc_check () {
203 : nothing
204 }
205 else
206 setup_malloc_check () {
207 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
208 export MALLOC_CHECK_ MALLOC_PERTURB_
209 }
210 teardown_malloc_check () {
211 unset MALLOC_CHECK_ MALLOC_PERTURB_
212 }
213 fi
214
215 # Protect ourselves from common misconfiguration to export
216 # CDPATH into the environment
217 unset CDPATH
218
219 unset GREP_OPTIONS
220 unset UNZIP
221
222 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
223 1|2|true)
224 GIT_TRACE=4
225 ;;
226 esac
227
228 # Convenience
229 #
230 # A regexp to match 5, 35 and 40 hexdigits
231 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
232 _x35="$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
233 _x40="$_x35$_x05"
234
235 # Zero SHA-1
236 _z40=0000000000000000000000000000000000000000
237
238 OID_REGEX="$_x40"
239 ZERO_OID=$_z40
240 EMPTY_TREE=4b825dc642cb6eb9a060e54bf8d69288fbee4904
241 EMPTY_BLOB=e69de29bb2d1d6434b8b29ae775ad8c2e48c5391
242
243 # Line feed
244 LF='
245 '
246
247 # UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
248 # when case-folding filenames
249 u200c=$(printf '\342\200\214')
250
251 export _x05 _x35 _x40 _z40 LF u200c EMPTY_TREE EMPTY_BLOB ZERO_OID OID_REGEX
252
253 # Each test should start with something like this, after copyright notices:
254 #
255 # test_description='Description of this test...
256 # This test checks if command xyzzy does the right thing...
257 # '
258 # . ./test-lib.sh
259 test "x$TERM" != "xdumb" && (
260 test -t 1 &&
261 tput bold >/dev/null 2>&1 &&
262 tput setaf 1 >/dev/null 2>&1 &&
263 tput sgr0 >/dev/null 2>&1
264 ) &&
265 color=t
266
267 while test "$#" -ne 0
268 do
269 case "$1" in
270 -d|--d|--de|--deb|--debu|--debug)
271 debug=t; shift ;;
272 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
273 immediate=t; shift ;;
274 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
275 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
276 -r)
277 shift; test "$#" -ne 0 || {
278 echo 'error: -r requires an argument' >&2;
279 exit 1;
280 }
281 run_list=$1; shift ;;
282 --run=*)
283 run_list=${1#--*=}; shift ;;
284 -h|--h|--he|--hel|--help)
285 help=t; shift ;;
286 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
287 verbose=t; shift ;;
288 --verbose-only=*)
289 verbose_only=${1#--*=}
290 shift ;;
291 -q|--q|--qu|--qui|--quie|--quiet)
292 # Ignore --quiet under a TAP::Harness. Saying how many tests
293 # passed without the ok/not ok details is always an error.
294 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
295 --with-dashes)
296 with_dashes=t; shift ;;
297 --no-color)
298 color=; shift ;;
299 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
300 valgrind=memcheck
301 shift ;;
302 --valgrind=*)
303 valgrind=${1#--*=}
304 shift ;;
305 --valgrind-only=*)
306 valgrind_only=${1#--*=}
307 shift ;;
308 --tee)
309 shift ;; # was handled already
310 --root=*)
311 root=${1#--*=}
312 shift ;;
313 --chain-lint)
314 GIT_TEST_CHAIN_LINT=1
315 shift ;;
316 --no-chain-lint)
317 GIT_TEST_CHAIN_LINT=0
318 shift ;;
319 -x)
320 # Some test scripts can't be reliably traced with '-x',
321 # unless the test is run with a Bash version supporting
322 # BASH_XTRACEFD (introduced in Bash v4.1). Check whether
323 # this test is marked as such, and ignore '-x' if it
324 # isn't executed with a suitable Bash version.
325 if test -z "$test_untraceable" || {
326 test -n "$BASH_VERSION" && eval '
327 test ${BASH_VERSINFO[0]} -gt 4 || {
328 test ${BASH_VERSINFO[0]} -eq 4 &&
329 test ${BASH_VERSINFO[1]} -ge 1
330 }
331 '
332 }
333 then
334 trace=t
335 else
336 echo >&2 "warning: ignoring -x; '$0' is untraceable without BASH_XTRACEFD"
337 fi
338 shift ;;
339 -V|--verbose-log)
340 verbose_log=t
341 shift ;;
342 *)
343 echo "error: unknown test option '$1'" >&2; exit 1 ;;
344 esac
345 done
346
347 if test -n "$valgrind_only"
348 then
349 test -z "$valgrind" && valgrind=memcheck
350 test -z "$verbose" && verbose_only="$valgrind_only"
351 elif test -n "$valgrind"
352 then
353 test -z "$verbose_log" && verbose=t
354 fi
355
356 if test -n "$trace" && test -z "$verbose_log"
357 then
358 verbose=t
359 fi
360
361 if test -n "$color"
362 then
363 # Save the color control sequences now rather than run tput
364 # each time say_color() is called. This is done for two
365 # reasons:
366 # * TERM will be changed to dumb
367 # * HOME will be changed to a temporary directory and tput
368 # might need to read ~/.terminfo from the original HOME
369 # directory to get the control sequences
370 # Note: This approach assumes the control sequences don't end
371 # in a newline for any terminal of interest (command
372 # substitutions strip trailing newlines). Given that most
373 # (all?) terminals in common use are related to ECMA-48, this
374 # shouldn't be a problem.
375 say_color_error=$(tput bold; tput setaf 1) # bold red
376 say_color_skip=$(tput setaf 4) # blue
377 say_color_warn=$(tput setaf 3) # brown/yellow
378 say_color_pass=$(tput setaf 2) # green
379 say_color_info=$(tput setaf 6) # cyan
380 say_color_reset=$(tput sgr0)
381 say_color_="" # no formatting for normal text
382 say_color () {
383 test -z "$1" && test -n "$quiet" && return
384 eval "say_color_color=\$say_color_$1"
385 shift
386 printf "%s\\n" "$say_color_color$*$say_color_reset"
387 }
388 else
389 say_color() {
390 test -z "$1" && test -n "$quiet" && return
391 shift
392 printf "%s\n" "$*"
393 }
394 fi
395
396 TERM=dumb
397 export TERM
398
399 error () {
400 say_color error "error: $*"
401 GIT_EXIT_OK=t
402 exit 1
403 }
404
405 BUG () {
406 error >&7 "bug in the test script: $*"
407 }
408
409 say () {
410 say_color info "$*"
411 }
412
413 if test -n "$HARNESS_ACTIVE"
414 then
415 if test "$verbose" = t || test -n "$verbose_only"
416 then
417 printf 'Bail out! %s\n' \
418 'verbose mode forbidden under TAP harness; try --verbose-log'
419 exit 1
420 fi
421 fi
422
423 test "${test_description}" != "" ||
424 error "Test script did not set test_description."
425
426 if test "$help" = "t"
427 then
428 printf '%s\n' "$test_description"
429 exit 0
430 fi
431
432 exec 5>&1
433 exec 6<&0
434 exec 7>&2
435 if test "$verbose_log" = "t"
436 then
437 exec 3>>"$GIT_TEST_TEE_OUTPUT_FILE" 4>&3
438 elif test "$verbose" = "t"
439 then
440 exec 4>&2 3>&1
441 else
442 exec 4>/dev/null 3>/dev/null
443 fi
444
445 # Send any "-x" output directly to stderr to avoid polluting tests
446 # which capture stderr. We can do this unconditionally since it
447 # has no effect if tracing isn't turned on.
448 #
449 # Note that this sets up the trace fd as soon as we assign the variable, so it
450 # must come after the creation of descriptor 4 above. Likewise, we must never
451 # unset this, as it has the side effect of closing descriptor 4, which we
452 # use to show verbose tests to the user.
453 #
454 # Note also that we don't need or want to export it. The tracing is local to
455 # this shell, and we would not want to influence any shells we exec.
456 BASH_XTRACEFD=4
457
458 test_failure=0
459 test_count=0
460 test_fixed=0
461 test_broken=0
462 test_success=0
463
464 test_external_has_tap=0
465
466 die () {
467 code=$?
468 if test -n "$GIT_EXIT_OK"
469 then
470 exit $code
471 else
472 echo >&5 "FATAL: Unexpected exit with code $code"
473 exit 1
474 fi
475 }
476
477 GIT_EXIT_OK=
478 trap 'die' EXIT
479 trap 'exit $?' INT
480
481 # The user-facing functions are loaded from a separate file so that
482 # test_perf subshells can have them too
483 . "$TEST_DIRECTORY/test-lib-functions.sh"
484
485 # You are not expected to call test_ok_ and test_failure_ directly, use
486 # the test_expect_* functions instead.
487
488 test_ok_ () {
489 test_success=$(($test_success + 1))
490 say_color "" "ok $test_count - $@"
491 }
492
493 test_failure_ () {
494 test_failure=$(($test_failure + 1))
495 say_color error "not ok $test_count - $1"
496 shift
497 printf '%s\n' "$*" | sed -e 's/^/# /'
498 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
499 }
500
501 test_known_broken_ok_ () {
502 test_fixed=$(($test_fixed+1))
503 say_color error "ok $test_count - $@ # TODO known breakage vanished"
504 }
505
506 test_known_broken_failure_ () {
507 test_broken=$(($test_broken+1))
508 say_color warn "not ok $test_count - $@ # TODO known breakage"
509 }
510
511 test_debug () {
512 test "$debug" = "" || eval "$1"
513 }
514
515 match_pattern_list () {
516 arg="$1"
517 shift
518 test -z "$*" && return 1
519 for pattern_
520 do
521 case "$arg" in
522 $pattern_)
523 return 0
524 esac
525 done
526 return 1
527 }
528
529 match_test_selector_list () {
530 title="$1"
531 shift
532 arg="$1"
533 shift
534 test -z "$1" && return 0
535
536 # Both commas and whitespace are accepted as separators.
537 OLDIFS=$IFS
538 IFS=' ,'
539 set -- $1
540 IFS=$OLDIFS
541
542 # If the first selector is negative we include by default.
543 include=
544 case "$1" in
545 !*) include=t ;;
546 esac
547
548 for selector
549 do
550 orig_selector=$selector
551
552 positive=t
553 case "$selector" in
554 !*)
555 positive=
556 selector=${selector##?}
557 ;;
558 esac
559
560 test -z "$selector" && continue
561
562 case "$selector" in
563 *-*)
564 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
565 then
566 echo "error: $title: invalid non-numeric in range" \
567 "start: '$orig_selector'" >&2
568 exit 1
569 fi
570 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
571 then
572 echo "error: $title: invalid non-numeric in range" \
573 "end: '$orig_selector'" >&2
574 exit 1
575 fi
576 ;;
577 *)
578 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
579 then
580 echo "error: $title: invalid non-numeric in test" \
581 "selector: '$orig_selector'" >&2
582 exit 1
583 fi
584 esac
585
586 # Short cut for "obvious" cases
587 test -z "$include" && test -z "$positive" && continue
588 test -n "$include" && test -n "$positive" && continue
589
590 case "$selector" in
591 -*)
592 if test $arg -le ${selector#-}
593 then
594 include=$positive
595 fi
596 ;;
597 *-)
598 if test $arg -ge ${selector%-}
599 then
600 include=$positive
601 fi
602 ;;
603 *-*)
604 if test ${selector%%-*} -le $arg \
605 && test $arg -le ${selector#*-}
606 then
607 include=$positive
608 fi
609 ;;
610 *)
611 if test $arg -eq $selector
612 then
613 include=$positive
614 fi
615 ;;
616 esac
617 done
618
619 test -n "$include"
620 }
621
622 maybe_teardown_verbose () {
623 test -z "$verbose_only" && return
624 exec 4>/dev/null 3>/dev/null
625 verbose=
626 }
627
628 last_verbose=t
629 maybe_setup_verbose () {
630 test -z "$verbose_only" && return
631 if match_pattern_list $test_count $verbose_only
632 then
633 exec 4>&2 3>&1
634 # Emit a delimiting blank line when going from
635 # non-verbose to verbose. Within verbose mode the
636 # delimiter is printed by test_expect_*. The choice
637 # of the initial $last_verbose is such that before
638 # test 1, we do not print it.
639 test -z "$last_verbose" && echo >&3 ""
640 verbose=t
641 else
642 exec 4>/dev/null 3>/dev/null
643 verbose=
644 fi
645 last_verbose=$verbose
646 }
647
648 maybe_teardown_valgrind () {
649 test -z "$GIT_VALGRIND" && return
650 GIT_VALGRIND_ENABLED=
651 }
652
653 maybe_setup_valgrind () {
654 test -z "$GIT_VALGRIND" && return
655 if test -z "$valgrind_only"
656 then
657 GIT_VALGRIND_ENABLED=t
658 return
659 fi
660 GIT_VALGRIND_ENABLED=
661 if match_pattern_list $test_count $valgrind_only
662 then
663 GIT_VALGRIND_ENABLED=t
664 fi
665 }
666
667 want_trace () {
668 test "$trace" = t && {
669 test "$verbose" = t || test "$verbose_log" = t
670 }
671 }
672
673 # This is a separate function because some tests use
674 # "return" to end a test_expect_success block early
675 # (and we want to make sure we run any cleanup like
676 # "set +x").
677 test_eval_inner_ () {
678 # Do not add anything extra (including LF) after '$*'
679 eval "
680 want_trace && set -x
681 $*"
682 }
683
684 test_eval_ () {
685 # If "-x" tracing is in effect, then we want to avoid polluting stderr
686 # with non-test commands. But once in "set -x" mode, we cannot prevent
687 # the shell from printing the "set +x" to turn it off (nor the saving
688 # of $? before that). But we can make sure that the output goes to
689 # /dev/null.
690 #
691 # There are a few subtleties here:
692 #
693 # - we have to redirect descriptor 4 in addition to 2, to cover
694 # BASH_XTRACEFD
695 #
696 # - the actual eval has to come before the redirection block (since
697 # it needs to see descriptor 4 to set up its stderr)
698 #
699 # - likewise, any error message we print must be outside the block to
700 # access descriptor 4
701 #
702 # - checking $? has to come immediately after the eval, but it must
703 # be _inside_ the block to avoid polluting the "set -x" output
704 #
705
706 test_eval_inner_ "$@" </dev/null >&3 2>&4
707 {
708 test_eval_ret_=$?
709 if want_trace
710 then
711 set +x
712 fi
713 } 2>/dev/null 4>&2
714
715 if test "$test_eval_ret_" != 0 && want_trace
716 then
717 say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
718 fi
719 return $test_eval_ret_
720 }
721
722 test_run_ () {
723 test_cleanup=:
724 expecting_failure=$2
725
726 if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
727 # turn off tracing for this test-eval, as it simply creates
728 # confusing noise in the "-x" output
729 trace_tmp=$trace
730 trace=
731 # 117 is magic because it is unlikely to match the exit
732 # code of other programs
733 if $(printf '%s\n' "$1" | sed -f "$GIT_BUILD_DIR/t/chainlint.sed" | grep -q '?![A-Z][A-Z]*?!') ||
734 test "OK-117" != "$(test_eval_ "(exit 117) && $1${LF}${LF}echo OK-\$?" 3>&1)"
735 then
736 BUG "broken &&-chain or run-away HERE-DOC: $1"
737 fi
738 trace=$trace_tmp
739 fi
740
741 setup_malloc_check
742 test_eval_ "$1"
743 eval_ret=$?
744 teardown_malloc_check
745
746 if test -z "$immediate" || test $eval_ret = 0 ||
747 test -n "$expecting_failure" && test "$test_cleanup" != ":"
748 then
749 setup_malloc_check
750 test_eval_ "$test_cleanup"
751 teardown_malloc_check
752 fi
753 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
754 then
755 echo ""
756 fi
757 return "$eval_ret"
758 }
759
760 test_start_ () {
761 test_count=$(($test_count+1))
762 maybe_setup_verbose
763 maybe_setup_valgrind
764 }
765
766 test_finish_ () {
767 echo >&3 ""
768 maybe_teardown_valgrind
769 maybe_teardown_verbose
770 }
771
772 test_skip () {
773 to_skip=
774 skipped_reason=
775 if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
776 then
777 to_skip=t
778 skipped_reason="GIT_SKIP_TESTS"
779 fi
780 if test -z "$to_skip" && test -n "$test_prereq" &&
781 ! test_have_prereq "$test_prereq"
782 then
783 to_skip=t
784
785 of_prereq=
786 if test "$missing_prereq" != "$test_prereq"
787 then
788 of_prereq=" of $test_prereq"
789 fi
790 skipped_reason="missing $missing_prereq${of_prereq}"
791 fi
792 if test -z "$to_skip" && test -n "$run_list" &&
793 ! match_test_selector_list '--run' $test_count "$run_list"
794 then
795 to_skip=t
796 skipped_reason="--run"
797 fi
798
799 case "$to_skip" in
800 t)
801 say_color skip >&3 "skipping test: $@"
802 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
803 : true
804 ;;
805 *)
806 false
807 ;;
808 esac
809 }
810
811 # stub; perf-lib overrides it
812 test_at_end_hook_ () {
813 :
814 }
815
816 test_done () {
817 GIT_EXIT_OK=t
818
819 if test -z "$HARNESS_ACTIVE"
820 then
821 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
822 mkdir -p "$test_results_dir"
823 base=${0##*/}
824 test_results_path="$test_results_dir/${base%.sh}.counts"
825
826 cat >"$test_results_path" <<-EOF
827 total $test_count
828 success $test_success
829 fixed $test_fixed
830 broken $test_broken
831 failed $test_failure
832
833 EOF
834 fi
835
836 if test "$test_fixed" != 0
837 then
838 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
839 fi
840 if test "$test_broken" != 0
841 then
842 say_color warn "# still have $test_broken known breakage(s)"
843 fi
844 if test "$test_broken" != 0 || test "$test_fixed" != 0
845 then
846 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
847 msg="remaining $test_remaining test(s)"
848 else
849 test_remaining=$test_count
850 msg="$test_count test(s)"
851 fi
852 case "$test_failure" in
853 0)
854 if test $test_external_has_tap -eq 0
855 then
856 if test $test_remaining -gt 0
857 then
858 say_color pass "# passed all $msg"
859 fi
860
861 # Maybe print SKIP message
862 test -z "$skip_all" || skip_all="# SKIP $skip_all"
863 case "$test_count" in
864 0)
865 say "1..$test_count${skip_all:+ $skip_all}"
866 ;;
867 *)
868 test -z "$skip_all" ||
869 say_color warn "$skip_all"
870 say "1..$test_count"
871 ;;
872 esac
873 fi
874
875 if test -z "$debug"
876 then
877 test -d "$TRASH_DIRECTORY" ||
878 error "Tests passed but trash directory already removed before test cleanup; aborting"
879
880 cd "$TRASH_DIRECTORY/.." &&
881 rm -fr "$TRASH_DIRECTORY" ||
882 error "Tests passed but test cleanup failed; aborting"
883 fi
884 test_at_end_hook_
885
886 exit 0 ;;
887
888 *)
889 if test $test_external_has_tap -eq 0
890 then
891 say_color error "# failed $test_failure among $msg"
892 say "1..$test_count"
893 fi
894
895 exit 1 ;;
896
897 esac
898 }
899
900 if test -n "$valgrind"
901 then
902 make_symlink () {
903 test -h "$2" &&
904 test "$1" = "$(readlink "$2")" || {
905 # be super paranoid
906 if mkdir "$2".lock
907 then
908 rm -f "$2" &&
909 ln -s "$1" "$2" &&
910 rm -r "$2".lock
911 else
912 while test -d "$2".lock
913 do
914 say "Waiting for lock on $2."
915 sleep 1
916 done
917 fi
918 }
919 }
920
921 make_valgrind_symlink () {
922 # handle only executables, unless they are shell libraries that
923 # need to be in the exec-path.
924 test -x "$1" ||
925 test "# " = "$(test_copy_bytes 2 <"$1")" ||
926 return;
927
928 base=$(basename "$1")
929 case "$base" in
930 test-*)
931 symlink_target="$GIT_BUILD_DIR/t/helper/$base"
932 ;;
933 *)
934 symlink_target="$GIT_BUILD_DIR/$base"
935 ;;
936 esac
937 # do not override scripts
938 if test -x "$symlink_target" &&
939 test ! -d "$symlink_target" &&
940 test "#!" != "$(test_copy_bytes 2 <"$symlink_target")"
941 then
942 symlink_target=../valgrind.sh
943 fi
944 case "$base" in
945 *.sh|*.perl)
946 symlink_target=../unprocessed-script
947 esac
948 # create the link, or replace it if it is out of date
949 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
950 }
951
952 # override all git executables in TEST_DIRECTORY/..
953 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
954 mkdir -p "$GIT_VALGRIND"/bin
955 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/t/helper/test-*
956 do
957 make_valgrind_symlink $file
958 done
959 # special-case the mergetools loadables
960 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
961 OLDIFS=$IFS
962 IFS=:
963 for path in $PATH
964 do
965 ls "$path"/git-* 2> /dev/null |
966 while read file
967 do
968 make_valgrind_symlink "$file"
969 done
970 done
971 IFS=$OLDIFS
972 PATH=$GIT_VALGRIND/bin:$PATH
973 GIT_EXEC_PATH=$GIT_VALGRIND/bin
974 export GIT_VALGRIND
975 GIT_VALGRIND_MODE="$valgrind"
976 export GIT_VALGRIND_MODE
977 GIT_VALGRIND_ENABLED=t
978 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
979 export GIT_VALGRIND_ENABLED
980 elif test -n "$GIT_TEST_INSTALLED"
981 then
982 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
983 error "Cannot run git from $GIT_TEST_INSTALLED."
984 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR/t/helper:$PATH
985 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
986 else # normal case, use ../bin-wrappers only unless $with_dashes:
987 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
988 if ! test -x "$git_bin_dir/git"
989 then
990 if test -z "$with_dashes"
991 then
992 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
993 fi
994 with_dashes=t
995 fi
996 PATH="$git_bin_dir:$PATH"
997 GIT_EXEC_PATH=$GIT_BUILD_DIR
998 if test -n "$with_dashes"
999 then
1000 PATH="$GIT_BUILD_DIR:$PATH"
1001 fi
1002 fi
1003 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
1004 GIT_CONFIG_NOSYSTEM=1
1005 GIT_ATTR_NOSYSTEM=1
1006 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
1007
1008 if test -z "$GIT_TEST_CMP"
1009 then
1010 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
1011 then
1012 GIT_TEST_CMP="$DIFF -c"
1013 else
1014 GIT_TEST_CMP="$DIFF -u"
1015 fi
1016 fi
1017
1018 GITPERLLIB="$GIT_BUILD_DIR"/perl/build/lib
1019 export GITPERLLIB
1020 test -d "$GIT_BUILD_DIR"/templates/blt || {
1021 error "You haven't built things yet, have you?"
1022 }
1023
1024 if ! test -x "$GIT_BUILD_DIR"/t/helper/test-tool
1025 then
1026 echo >&2 'You need to build test-tool:'
1027 echo >&2 'Run "make t/helper/test-tool" in the source (toplevel) directory'
1028 exit 1
1029 fi
1030
1031 # Test repository
1032 TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
1033 test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
1034 case "$TRASH_DIRECTORY" in
1035 /*) ;; # absolute path is good
1036 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
1037 esac
1038 rm -fr "$TRASH_DIRECTORY" || {
1039 GIT_EXIT_OK=t
1040 echo >&5 "FATAL: Cannot prepare test area"
1041 exit 1
1042 }
1043
1044 HOME="$TRASH_DIRECTORY"
1045 GNUPGHOME="$HOME/gnupg-home-not-used"
1046 export HOME GNUPGHOME
1047
1048 if test -z "$TEST_NO_CREATE_REPO"
1049 then
1050 test_create_repo "$TRASH_DIRECTORY"
1051 else
1052 mkdir -p "$TRASH_DIRECTORY"
1053 fi
1054 # Use -P to resolve symlinks in our working directory so that the cwd
1055 # in subprocesses like git equals our $PWD (for pathname comparisons).
1056 cd -P "$TRASH_DIRECTORY" || exit 1
1057
1058 this_test=${0##*/}
1059 this_test=${this_test%%-*}
1060 if match_pattern_list "$this_test" $GIT_SKIP_TESTS
1061 then
1062 say_color info >&3 "skipping test $this_test altogether"
1063 skip_all="skip all tests in $this_test"
1064 test_done
1065 fi
1066
1067 # Provide an implementation of the 'yes' utility
1068 yes () {
1069 if test $# = 0
1070 then
1071 y=y
1072 else
1073 y="$*"
1074 fi
1075
1076 i=0
1077 while test $i -lt 99
1078 do
1079 echo "$y"
1080 i=$(($i+1))
1081 done
1082 }
1083
1084 # Fix some commands on Windows
1085 uname_s=$(uname -s)
1086 case $uname_s in
1087 *MINGW*)
1088 # Windows has its own (incompatible) sort and find
1089 sort () {
1090 /usr/bin/sort "$@"
1091 }
1092 find () {
1093 /usr/bin/find "$@"
1094 }
1095 # git sees Windows-style pwd
1096 pwd () {
1097 builtin pwd -W
1098 }
1099 # no POSIX permissions
1100 # backslashes in pathspec are converted to '/'
1101 # exec does not inherit the PID
1102 test_set_prereq MINGW
1103 test_set_prereq NATIVE_CRLF
1104 test_set_prereq SED_STRIPS_CR
1105 test_set_prereq GREP_STRIPS_CR
1106 GIT_TEST_CMP=mingw_test_cmp
1107 ;;
1108 *CYGWIN*)
1109 test_set_prereq POSIXPERM
1110 test_set_prereq EXECKEEPSPID
1111 test_set_prereq CYGWIN
1112 test_set_prereq SED_STRIPS_CR
1113 test_set_prereq GREP_STRIPS_CR
1114 ;;
1115 *)
1116 test_set_prereq POSIXPERM
1117 test_set_prereq BSLASHPSPEC
1118 test_set_prereq EXECKEEPSPID
1119 ;;
1120 esac
1121
1122 ( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1123 test -z "$NO_PERL" && test_set_prereq PERL
1124 test -z "$NO_PTHREADS" && test_set_prereq PTHREADS
1125 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1126 test -n "$USE_LIBPCRE1$USE_LIBPCRE2" && test_set_prereq PCRE
1127 test -n "$USE_LIBPCRE1" && test_set_prereq LIBPCRE1
1128 test -n "$USE_LIBPCRE2" && test_set_prereq LIBPCRE2
1129 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1130
1131 if test -n "$GIT_TEST_GETTEXT_POISON_ORIG"
1132 then
1133 GIT_TEST_GETTEXT_POISON=$GIT_TEST_GETTEXT_POISON_ORIG
1134 unset GIT_TEST_GETTEXT_POISON_ORIG
1135 fi
1136
1137 # Can we rely on git's output in the C locale?
1138 if test -z "$GIT_TEST_GETTEXT_POISON"
1139 then
1140 test_set_prereq C_LOCALE_OUTPUT
1141 fi
1142
1143 if test -z "$GIT_TEST_CHECK_CACHE_TREE"
1144 then
1145 GIT_TEST_CHECK_CACHE_TREE=true
1146 export GIT_TEST_CHECK_CACHE_TREE
1147 fi
1148
1149 test_lazy_prereq PIPE '
1150 # test whether the filesystem supports FIFOs
1151 test_have_prereq !MINGW,!CYGWIN &&
1152 rm -f testfifo && mkfifo testfifo
1153 '
1154
1155 test_lazy_prereq SYMLINKS '
1156 # test whether the filesystem supports symbolic links
1157 ln -s x y && test -h y
1158 '
1159
1160 test_lazy_prereq FILEMODE '
1161 test "$(git config --bool core.filemode)" = true
1162 '
1163
1164 test_lazy_prereq CASE_INSENSITIVE_FS '
1165 echo good >CamelCase &&
1166 echo bad >camelcase &&
1167 test "$(cat CamelCase)" != good
1168 '
1169
1170 test_lazy_prereq FUNNYNAMES '
1171 test_have_prereq !MINGW &&
1172 touch -- \
1173 "FUNNYNAMES tab embedded" \
1174 "FUNNYNAMES \"quote embedded\"" \
1175 "FUNNYNAMES newline
1176 embedded" 2>/dev/null &&
1177 rm -- \
1178 "FUNNYNAMES tab embedded" \
1179 "FUNNYNAMES \"quote embedded\"" \
1180 "FUNNYNAMES newline
1181 embedded" 2>/dev/null
1182 '
1183
1184 test_lazy_prereq UTF8_NFD_TO_NFC '
1185 # check whether FS converts nfd unicode to nfc
1186 auml=$(printf "\303\244")
1187 aumlcdiar=$(printf "\141\314\210")
1188 >"$auml" &&
1189 test -f "$aumlcdiar"
1190 '
1191
1192 test_lazy_prereq AUTOIDENT '
1193 sane_unset GIT_AUTHOR_NAME &&
1194 sane_unset GIT_AUTHOR_EMAIL &&
1195 git var GIT_AUTHOR_IDENT
1196 '
1197
1198 test_lazy_prereq EXPENSIVE '
1199 test -n "$GIT_TEST_LONG"
1200 '
1201
1202 test_lazy_prereq EXPENSIVE_ON_WINDOWS '
1203 test_have_prereq EXPENSIVE || test_have_prereq !MINGW,!CYGWIN
1204 '
1205
1206 test_lazy_prereq USR_BIN_TIME '
1207 test -x /usr/bin/time
1208 '
1209
1210 test_lazy_prereq NOT_ROOT '
1211 uid=$(id -u) &&
1212 test "$uid" != 0
1213 '
1214
1215 test_lazy_prereq JGIT '
1216 type jgit
1217 '
1218
1219 # SANITY is about "can you correctly predict what the filesystem would
1220 # do by only looking at the permission bits of the files and
1221 # directories?" A typical example of !SANITY is running the test
1222 # suite as root, where a test may expect "chmod -r file && cat file"
1223 # to fail because file is supposed to be unreadable after a successful
1224 # chmod. In an environment (i.e. combination of what filesystem is
1225 # being used and who is running the tests) that lacks SANITY, you may
1226 # be able to delete or create a file when the containing directory
1227 # doesn't have write permissions, or access a file even if the
1228 # containing directory doesn't have read or execute permissions.
1229
1230 test_lazy_prereq SANITY '
1231 mkdir SANETESTD.1 SANETESTD.2 &&
1232
1233 chmod +w SANETESTD.1 SANETESTD.2 &&
1234 >SANETESTD.1/x 2>SANETESTD.2/x &&
1235 chmod -w SANETESTD.1 &&
1236 chmod -r SANETESTD.1/x &&
1237 chmod -rx SANETESTD.2 ||
1238 BUG "cannot prepare SANETESTD"
1239
1240 ! test -r SANETESTD.1/x &&
1241 ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1242 status=$?
1243
1244 chmod +rwx SANETESTD.1 SANETESTD.2 &&
1245 rm -rf SANETESTD.1 SANETESTD.2 ||
1246 BUG "cannot clean SANETESTD"
1247 return $status
1248 '
1249
1250 test FreeBSD != $uname_s || GIT_UNZIP=${GIT_UNZIP:-/usr/local/bin/unzip}
1251 GIT_UNZIP=${GIT_UNZIP:-unzip}
1252 test_lazy_prereq UNZIP '
1253 "$GIT_UNZIP" -v
1254 test $? -ne 127
1255 '
1256
1257 run_with_limited_cmdline () {
1258 (ulimit -s 128 && "$@")
1259 }
1260
1261 test_lazy_prereq CMDLINE_LIMIT '
1262 test_have_prereq !MINGW,!CYGWIN &&
1263 run_with_limited_cmdline true
1264 '
1265
1266 run_with_limited_stack () {
1267 (ulimit -s 128 && "$@")
1268 }
1269
1270 test_lazy_prereq ULIMIT_STACK_SIZE '
1271 test_have_prereq !MINGW,!CYGWIN &&
1272 run_with_limited_stack true
1273 '
1274
1275 build_option () {
1276 git version --build-options |
1277 sed -ne "s/^$1: //p"
1278 }
1279
1280 test_lazy_prereq LONG_IS_64BIT '
1281 test 8 -le "$(build_option sizeof-long)"
1282 '
1283
1284 test_lazy_prereq TIME_IS_64BIT 'test-tool date is64bit'
1285 test_lazy_prereq TIME_T_IS_64BIT 'test-tool date time_t-is64bit'
1286
1287 test_lazy_prereq CURL '
1288 curl --version
1289 '
1290
1291 # SHA1 is a test if the hash algorithm in use is SHA-1. This is both for tests
1292 # which will not work with other hash algorithms and tests that work but don't
1293 # test anything meaningful (e.g. special values which cause short collisions).
1294 test_lazy_prereq SHA1 '
1295 test $(git hash-object /dev/null) = e69de29bb2d1d6434b8b29ae775ad8c2e48c5391
1296 '
1297
1298 test_lazy_prereq REBASE_P '
1299 test -z "$GIT_TEST_SKIP_REBASE_P"
1300 '